// Hľadanie a oprava slova so spojovníkom na konci riadka
// Podľa Find Hyphenations version 1.2, (c) http://in-tools.com
// (c) JP, verzia 2014.11.19
var gSlovo="";
var gAkoZamenit=0;
var gKoniec=false;
var gZamena=true;
main();

function main(){
 var Vyber=app.selection;
 if(!Vyber || Vyber.length!=1) {
  alert("Vyberte text!");
  return;
 }
 Vyber=Vyber[0];
 if(! (Vyber.hasOwnProperty("baseline"))) {
  alert("Vyberte text!");
  return;
 }
 var AktualnyIndex = Vyber.insertionPoints[-1].index;
 var Odsek = Vyber.parentStory;
 if(AktualnyIndex>=Odsek.characters.length){AktualnyIndex=-1}
 var text=Odsek.texts.itemByRange(Odsek.characters[AktualnyIndex],Odsek.characters[-1]);
 for(var i=0;i<text.words.length;i++){
  //Ak je slovo na viac riadkoch a jeho posledná pozícia na prvom riadku je spojovník
  if ((text.words[i].lines.length>1) && (text.words[i].lines[0].characters[-1].contents=="-")) {
   ShowIt(text.words[i]);
   gSlovo=app.selection[0].contents;
   do {
    ZobrazDialog();
    if (gZamena==true) {
     if (gAkoZamenit==0) {
      app.selection[0].contents=gSlovo;
      //Ak sa počas zámeny zmení posledný znak na riadku, potom už nie je možná ďalšia zámena
      gZamena=((text.words[i].lines.length>1) && (text.words[i].lines[0].characters[-1].contents=="-"));
     }
     else {RozdelSlovo(text.words[i].lines[0])}
    }
   } while(gZamena==true);
   gAkoZamenit=0;
   gZamena=true;
   if (gKoniec==true) {return}
  }
 }
 alert("Nenájdené slová so spojovníkom na konci riadka!");
}

function ZobrazDialog () {
 var ZamenDialog=new Window ("dialog", "Nastavenie spojovníkov na konci riadka");

 var Zameny=ZamenDialog.add ("group {orientation: 'column'}");
 Zameny.add ("statictext", undefined, "Spojovník na konci riadka zameniť na:");
 if (gAkoZamenit==0) {
  var Riad=Zameny.add ("button", undefined, "Spojovník + zalomenie riadka + spojovník");
  var Typo=Zameny.add ("button", undefined, "Neviditeľný + nedeliteľný spojovník");
  
  Riad.onClick = function() {gAkoZamenit=1; ZamenDialog.close()}
  Typo.onClick = function() {gAkoZamenit=2; ZamenDialog.close()}
 }
 else {
  var Obyc=Zameny.add ("button", undefined, "Obyčajný spojovník");
  
  Obyc.onClick = function() {gAkoZamenit=0; ZamenDialog.close()}
 }         
 var Koniec=ZamenDialog.add ("group {orientation: 'row'}");
 Koniec.add ("statictext", undefined, " ");
 var ok=Koniec.add ("button", undefined, "Hľadať ďalší");
 var cancel=Koniec.add ("button", undefined, "Koniec");
  
 ok.onClick = function() {gZamena=false; ZamenDialog.close()}
 cancel.onClick = function() {gKoniec=true; gZamena=false; ZamenDialog.close()}
 
 ZamenDialog.show();
}

function RozdelSlovo(slovo){
 if (gAkoZamenit==1) {
  //Neviditeľný a nedeliteľný spojovník
  //Spojovník zameníme za neviditeľný spojovník a nedeliteľný spojovník
  slovo.characters[-1].contents = "\u00AD"+"\u2011";
 }
 if (gAkoZamenit==2) {
  //Spojovník, zalomenie riadka, spojovník
  //Za posledný znak riadka (spojovník) vložíme zalomenie riadka
  slovo.characters[-1].insertionPoints[1].contents = SpecialCharacters.FORCED_LINE_BREAK;
  //a za zalomenie riadka vložíme spojovník
  slovo.characters[-1].insertionPoints[1].contents = "-";
 }
}

function ShowIt(theObj) {// Select object, turn to page and center it in the window
 if (arguments.length > 0) {
  app.select(theObj);
  try{
   var thePage = FindWhere(theObj);
   if(thePage){
    app.activeWindow.activePage = thePage;
   }
  }catch(e){}
 }
 // Note: if no object is passed and there is no selection the current page
 // will be centered in the window at whatever zoom is being used
 var myZoom = app.activeWindow.zoomPercentage;
 app.activeWindow.zoom(ZoomOptions.showPasteboard);
 app.activeWindow.zoomPercentage = myZoom;
}

function FindWhere(obj, where){
 var getTextContainer = function (s){
  if(kAppVersion<5){return s.textFrames[-1]}else{return s.textContainers[s.textContainers.length-1]}
 }
 var getobj = function (fm){ //returns the parent text frame, or the last one of the parnet story
  if(fm != undefined){return fm;}else{return getTextContainer(obj.parentStory);}
 }
 var getobj_ptf  = function (obj){ //get the parent text frame or return the original object (necessary for Notes)
  try{ return obj.parentTextFrames[0]}catch(e){return obj}
 }
 var getobj_cell = function (fm){ //returns the parent text frame, or the last one of the parnet story -- for cells
  if(fm != undefined){return fm;}else{return getTextContainer(obj.insertionPoints[0].parentStory);}
 }
 var getnote_tf = function (note){ //gets the note location for both footnotes and notes in all versions...
  if(kAppVersion<5){
   if(note.hasOwnProperty("footnoteTextFrame")){var parentFrame = note.footnoteTextFrame}//no good for overset...
   else{var parentFrame = note.parentTextFrame}
   if(parentFrame){return parentFrame}
   else{return note.parent}
  }
  else{return note.storyOffset}
 }
 var e;
 if(!obj){return null}
 if(where == undefined){var where = Page;}
 if(where == Page && kAppVersion > 6 && (obj.parent instanceof Spread || obj.parent instanceof MasterSpread)){
  return obj.parentPage;
 }
 if(obj.hasOwnProperty("baseline")){obj = getobj(getobj_ptf (obj))}
 while(obj){
  if(where == Page && kAppVersion > 6 && (obj.parent instanceof Spread || obj.parent instanceof MasterSpread)){
   return obj.parentPage;
  }
  switch(obj.constructor){
   case where: return obj;
   case Story: obj = getTextContainer(obj);break;
   case Character: obj = getobj(getobj_ptf (obj));break;
   case Cell: obj = getobj_cell(getobj_ptf(obj.insertionPoints[0]));break;
   case Note:
   case Footnote: obj = getnote_tf(obj);break;
   case Application: return null;
  }
  if (!obj) return null; 
  obj = obj.parent;
 }
 return null;
}//end function findWhere
